
import java.io.*;
import java.util.*;
import java.text.*;

public class Loader
{
    public static void main(String args[]) {
		Node root = load();
		show(root, "");
	}
	public static void show(Node node, String indent){
		System.out.println(indent+node.name+"   "+node.code);
		int n = Math.min(5, node.children.size());
		for(int i=0; i<n; i++){
			show((Node) node.children.elementAt(i), indent+" ");
		}
		if (node.children.size() > n){
			System.out.println(indent+" ...");
		}
	}
	
			
	public static Node load(){
		
		String load_filename = "zipcode.txt";
		
		Node root = new Node("{");

		try{
			
		FileInputStream fis = new FileInputStream ( load_filename );
		BufferedReader r = new BufferedReader(new InputStreamReader(fis, "SJIS"));
		
		
		String line;
		StringTokenizer st;
		
		long code;
		String prefecture_name;
		String city_name;
		String area_name;
		
		String prev_prefecture_name = "";
		String prev_city_name = "";
		
		Node prefecture_node = null;
		Node city_node = null;
		Node area_node = null;
		
		while(true){
			line = r.readLine();
			if (line == null)
				break;
			
			st = new StringTokenizer(line);
			code = (new Long(st.nextToken())).longValue();	//VX֔ԍ(7
			prefecture_name = st.nextToken(); //s{	
			city_name		= st.nextToken(); //s撬	
			area_name		= st.nextToken(); //於		
			
			if (!prev_prefecture_name.equals(prefecture_name)){
				prefecture_node = new Node(prefecture_name);
				root.addChild(prefecture_node);

				prev_prefecture_name = prefecture_name;
			}
			if (!prev_city_name.equals(city_name)){
				city_node = new Node(city_name);
				prefecture_node.addChild(city_node);

				prev_city_name = city_name;
			}
			
			area_node = new Node(area_name);
			area_node.code = code;
			city_node.addChild(area_node);
			
		}
		
		r.close();

		}
		catch(IOException e){
			System.out.println("Exception "+e);
		};		
		 
		return root;
	}
			
}
